package com.hoolai.demo;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.ClipboardManager;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Configuration;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hoolai.access.log.LogUtils;
import com.hoolai.demo.share.FacebookShareActivity;
import com.hoolai.demo.share.ShareActivity;
import com.hoolai.demo.utils.DataReportUtil;
import com.hoolai.fastsdk.demo.R;
import com.hoolai.open.fastaccess.channel.ExitCallback;
import com.hoolai.open.fastaccess.channel.FastSdk;
import com.hoolai.open.fastaccess.channel.InitCallback;
import com.hoolai.open.fastaccess.channel.PayCallback;
import com.hoolai.open.fastaccess.channel.PayParams;
import com.hoolai.open.fastaccess.channel.UserExtDataKeys;
import com.hoolai.open.fastaccess.channel.UserLoginResponse;
import com.hoolai.open.fastaccess.channel.callback.CommonCallback;
import com.hoolai.open.fastaccess.channel.callback.LoginCallback;
import com.hoolai.open.fastaccess.channel.callback.PayProduct;
import com.hoolai.open.fastaccess.channel.callback.ProductCallback;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

public class GameActivity extends Activity implements View.OnClickListener {

    public static final String TAG = "fastaccessGameDemo";

    Button gameLoginBtn;
    Button LanguageBtn;
    private String msg;
    private String callbackInfo = "0|6867485|nw_001";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //SysUtil.setFuLLScreen(this);
        setContentView(R.layout.hl_demo_login);
        initData();
    }

    /**
     * 设置回调信息
     */
    private void initData() {
        //设置初始化回调
        InitCallback initCallback = new InitCallback() {

            @Override
            public void onInitSuccess(String s) {
                LogUtils.e("初始化成功:" + FastSdk.getChannelInfo().getInitParams());
                //sdk初始化成功
                //成功回调信息为json串，其中包含channel、biChannel，channelId和productId
                //注意此时返回的channel不能用于server端登录验证时的channel，登录验证使用的是登录成功后回调的channel值
                setLoginCallback();
                paintLogin();

                // funCode = 120（信鸽初始化，只有此功能必接，其他信鸽功能选接）
                if (FastSdk.hasFunctionCode(120)) {
                    FastSdk.invokeSpecialFunction(120, new CommonCallback() {
                        @Override
                        public void process(int i, boolean b, Object... objects) {
                            if (objects[0] instanceof org.json.JSONObject) {
                                JSONObject result = (JSONObject) objects[0];
                            }
                        }
                    });
                }
            }

            @Override
            public void onInitFail(String s) {
                //sdk初始化失败,初始化失败不能调用FastSdk其他接口
            }
        };
        FastSdk.onCreate(this, initCallback);

//        // 获取当前SDK版本号接口
        String sdkVersion = FastSdk.getSdkVersion();
        //Log.i(AbstractChannelInterfaceImpl.TAG, "当前SDK版本号：" + sdkVersion);
    }

    /**
     * 设置登录回调
     */
    private void setLoginCallback() {
        FastSdk.setLoginCallback(new LoginCallback() {
            @Override
            public void onLoginFailed(String s) {
                // onLoginFailed 登录失败（取消登录框）回调，并不是每个渠道都会有这个回调，所以建议在登录界面上放一个登陆按钮。
                //避免取消登录框以后无法登录的情况。
                Log.d(TAG, "登陆失败:" + s);
            }

            @Override
            public void onLoginSuccess(UserLoginResponse userLoginResponse) {
                LogUtils.e(TAG, "登陆成功:" + JSON.toJSONString(userLoginResponse));
                try {
                    //模拟报送数据
                    sendDataReport(userLoginResponse);
                    // 自定义指标打点报送
                    //userExtData.put(UserExtDataKeys.ACTION, "zdy");
                    //userExtData.put(UserExtDataKeys.PHYLUM, "5");
                    //userExtData.put(UserExtDataKeys.CLASSFIELD, "zdy555");
                    //FastSdk.setUserExtData(GameActivity.this, userExtData);

                    //渠道登录成功
                    Integer productId = FastSdk.getChannelInfo().getProductId();
                    String accessToken = userLoginResponse.getAccessToken();
                    Long uid = userLoginResponse.getUid();//接入平台的用户id
                    //channel对应的各渠道值查询http://access.hoolai.com/access_web/channelEnumList.do
                    String channel = userLoginResponse.getChannel();//渠道
                    String channelUid = userLoginResponse.getChannelUid();//渠道的用户id
                    //将以上参数，传给产品的服务器端， 产品的服务器端去接入平台的服务器去验证当前用户登录是否有效,
                    //参考服务端接入http://access.hoolai.com/doc/2016/02/16/%E6%9C%8D%E5%8A%A1%E7%AB%AF%E6%8E%A5%E5%8

                    String name = userLoginResponse.getNickName();
                    Integer channelId = FastSdk.getChannelInfo().getId();
                    String biChannel = FastSdk.getChannelInfo().getBiChannel();
//                    String udid = AccessHttpService.getUDID();
                    // 如果是YSDK渠道，判断是QQ还是微信登录
                    if (FastSdk.getChannelInfo().getChannel().equals("hoolaiysdk")) {
                        Boolean isQQ = (Boolean) userLoginResponse.getExtendInfo().get("isQQ");
                    }
                    // 如果是胡莱官网渠道
                    if (FastSdk.getChannelInfo().getChannel().equals("hoolai")) {
                        Boolean isBindPhone = (Boolean) userLoginResponse.getExtendInfo().get("isBindPhone");
                        Boolean isBindEmail = (Boolean) userLoginResponse.getExtendInfo().get("isBindEmail");
                    }

                    msg = "hoolai_uid：" + uid + "\n名称：" + name + "\n产品ID：" + productId + "\n渠道ID：" + channelId + "\nchannelUid：" + channelUid + "\nchannel：" + channel
                            + "\nbiChannel：" + biChannel + "\nUDID：" ;//+ udid;

                    // 验证通过进入游戏
                    paintGame();
                } catch (Exception e) {
                    Log.e(TAG, "验证access出现异常", e);
                }
            }

            @Override
            public void onLogout(Object... objects) {
                //登出回调逻辑请重点关注，这里是接入完成以后，测试的时候最容易出问题的地方
                //调用FastSdk.logout(this,null)会触发该回调方法
                //某些sdk的浮标里有切换账号 注销账号的时候也会调用该接口

                //这里请不要直接调用sdk的login接口
                //渠道要求在游戏运行的任何时刻均可正常登出帐号，所以游戏需要具备完善的登出逻辑，
                //当收到渠道或者游戏自己的切换帐号或登出通知时，能中断游戏逻辑，清空游戏角色信息，返回登录界面，供用户切换其他帐号登录。
                //登出逻辑属于用户系统逻辑，认为随着游戏SDK的不断成熟，未来渠道均会提供切换帐号或登出逻辑。
                //目前有悬浮窗的渠道大部分会在悬浮窗中提供切换帐号功能，但剩余的渠道有部分仍需游戏自己处理，
                //所以强烈建议游戏中添加登出或切换帐号的按钮。
                paintLogin();
            }
        });
    }

    private void sendDataReport(UserLoginResponse userLoginResponse) {
        try {
            Map<String, String> userExtData = new HashMap<String, String>();
            userExtData.put(UserExtDataKeys.ROLE_ID, userLoginResponse.getChannelUid());
            userExtData.put(UserExtDataKeys.ROLE_NAME, userLoginResponse.getChannelUid());
            userExtData.put(UserExtDataKeys.ROLE_LEVEL, "1");
            userExtData.put(UserExtDataKeys.ROLE_ID, "11182");
            userExtData.put(UserExtDataKeys.PARTYNAME, "同福碗粥");
            userExtData.put(UserExtDataKeys.BALANCE, "0");
            userExtData.put(UserExtDataKeys.VIP, "0");
            userExtData.put(UserExtDataKeys.ZONE_ID, "1");
            userExtData.put(UserExtDataKeys.ZONE_NAME, "1区-雄霸天下");

            //基础打点报送模拟
            DataReportUtil.basisData(this, userExtData);
            //af_开头打点报送模拟
            DataReportUtil.afDataSend(this, userExtData);
            //普通扩展数据模拟报送
            DataReportUtil.DataSend(this, userExtData);

        } catch (Exception e) {
            LogUtils.e("report Data send Exception:" + e.getMessage());
        }

    }

    /**
     * 启动登录界面
     */
    private void paintLogin() {
        setContentView(R.layout.hl_demo_login);
        gameLoginBtn = (Button) findViewById(R.id.gameLoginBtn);

        gameLoginBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // 调用SDK登录功能
                FastSdk.login(GameActivity.this, null);
            }
        });

        LanguageBtn = (Button) findViewById(R.id.gameLanguageBtn);
        LanguageBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // 国际化设置语言
                final Map<String, String> supportLanguages = FastSdk.getSupportLanguages(GameActivity.this);
//                LogUtils.i(JSON.toJSONString(supportLanguages));
                final String[] items = new String[supportLanguages.size()];
                int index = 0;
                for (Map.Entry<String, String> e : supportLanguages.entrySet()) {
                    items[index++] = e.getKey() + "--" + e.getValue();
                }
                new AlertDialog.Builder(GameActivity.this)
                        .setTitle("语言切换")
                        .setItems(items, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialogInterface, int i) {
                                String item = items[i];
                                FastSdk.switchLanguage(GameActivity.this, item.split("--")[0]);
                            }
                        }).show();
            }
        });
    }

    /**
     * 启动游戏主界面
     */
    private void paintGame() {
        this.setContentView(R.layout.hl_demo_game);
        TextView textView = (TextView) this.findViewById(R.id.showMessage);
        textView.setText(msg);
        this.findViewById(R.id.btnCopy).setOnClickListener(this);
        this.findViewById(R.id.btnCallbackLength).setOnClickListener(this);
        this.findViewById(R.id.btnCallbackText).setOnClickListener(this);
        this.findViewById(R.id.btnGetMetaData).setOnClickListener(this);
        this.findViewById(R.id.btnGetBalance).setOnClickListener(this);
        this.findViewById(R.id.btnEnterPay).setOnClickListener(this);
        this.findViewById(R.id.btnLogout).setOnClickListener(this);
        this.findViewById(R.id.btnExitSDK).setOnClickListener(this);
        this.findViewById(R.id.btnOpenService).setOnClickListener(this);
        this.findViewById(R.id.crash).setOnClickListener(this);
        this.findViewById(R.id.anr).setOnClickListener(this);
        this.findViewById(R.id.error).setOnClickListener(this);
        findViewById(R.id.btnGetSpecialFuncCodes).setOnClickListener(this);
        findViewById(R.id.btnInvokeSpecialFunc).setOnClickListener(this);
        findViewById(R.id.btnFbShare).setOnClickListener(this);

        Button btnAccountManage = (Button) this.findViewById(R.id.btnAccountManage);

        if (FastSdk.hasAccountManage()) {
            btnAccountManage.setVisibility(View.VISIBLE);
            btnAccountManage.setOnClickListener(this);
        } else {
            btnAccountManage.setVisibility(View.GONE);
        }
    }

    @Override
    public void onClick(View v) {
        int id = v.getId();
        if (id == R.id.btnCopy) {// 复制
            copyClipboard(msg);
        } else if (id == R.id.btnCallbackLength) {
            setGameCallback();
        } else if (id == R.id.btnCallbackText) {
            setGameCallbackText();
        } else if (id == R.id.btnOpenService) {
            //打开客服(可选)
            FastSdk.customerService(this);
        } else if (id == R.id.btnGetMetaData) {
            getMetaData();
        } else if (id == R.id.btnEnterPay) {// 定额支付
            getProductInfo();
        } else if (id == R.id.btnExitSDK) {// 退出游戏
            exit();
        } else if (id == R.id.btnGetSpecialFuncCodes) {
            getSpecialFuncCodes();
        } else if (id == R.id.btnInvokeSpecialFunc) {
            invokeSpecialFun();
        } else if (id == R.id.btnAccountManage) {// 账号管理
            FastSdk.accountManage(GameActivity.this, null);
        } else if (id == R.id.btnLogout) {
            FastSdk.logout(this, "");
        } else if (id == R.id.btnFbShare) {
            startActivity(new Intent(this, ShareActivity.class));
        } else if (id == R.id.crash) {
            int b = 100 / 0;
            int a = 1 / 0;
            LogUtils.i("崩溃异常");
        } else if (id == R.id.anr) {
            try {
                Thread.sleep(100000);
                startActivity(new Intent(this, FacebookShareActivity.class));
                LogUtils.i("出现ANR");
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        } else if (id == R.id.error) {
            try {
                int a = 2 / 0;
            } catch (Exception e) {
                FastSdk.crashReport(this, e);
                LogUtils.i("捕捉异常");
                e.printStackTrace();
            }
        }
    }

    /**
     * 特殊功能吗调用
     */
    private void invokeSpecialFun() {
        final EditText numberText = new EditText(GameActivity.this);
        numberText.setInputType(android.text.InputType.TYPE_CLASS_NUMBER);
        numberText.setHint("FunctionCode");
//        com.google.android.gms.measurement.PackageMeasurementTaskService
//        com.google.android.gms.clearcut.uploader.QosUploaderService
        new AlertDialog.Builder(GameActivity.this).setTitle("请输入功能码").setIcon(android.R.drawable.ic_dialog_info).setView(numberText)
                .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        String moneyStr = numberText.getText().toString();
                        if (TextUtils.isEmpty(moneyStr)) {
                            Toast.makeText(GameActivity.this, "请输入功能码", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        int funCode = Integer.parseInt(moneyStr);
                        specialInvoke(funCode);
                    }
                }).setNegativeButton("取消", null).show();
    }

    /**
     * 查看该渠道都有那些特殊功能
     */
    private void getSpecialFuncCodes() {
        for (Map.Entry<Integer, String> entry : FastSdk.getSpecialFunctionCodes().entrySet()) {
            LogUtils.w("FunctionCode=" + entry.getKey() + ",Desc=" + entry.getValue());
            Toast.makeText(GameActivity.this, "FunCode=" + entry.getKey() + ",Desc=" + entry.getValue(), Toast.LENGTH_SHORT).show();
        }
    }

    /**
     * 获取商品信息
     */
    private void getProductInfo() {
        //TODO:注意此处回调在子线程,如需操作UI界面需要切换线程
        FastSdk.getProductInfo(null, new ProductCallback() {
            @Override
            public void onProductInfo(final List<PayProduct> list) {
                final List<String> arrayList = new ArrayList();
                for (PayProduct payProduct : list) {
                    arrayList.add(JSON.toJSONString(payProduct));
                }
                LogUtils.i("Demo收到的商品信息返回arrayList:" + arrayList.toString());
                runOnUiThread(new Runnable() {

                    @Override
                    public void run() {
                        AlertDialog.Builder builder = new AlertDialog.Builder(GameActivity.this);
                        ListView listView = new ListView(GameActivity.this);
                        listView.setAdapter(new ArrayAdapter(GameActivity.this, android.R.layout.simple_list_item_1, android.R.id.text1, arrayList));
                        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                            @Override
                            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
//                            Toast.makeText(MainActivity.this,"你点击了支付"+position,Toast.LENGTH_SHORT).show();
                                String payInfo = (String) arrayList.get(position);
                                PayProduct payProduct = JSONObject.parseObject(payInfo, PayProduct.class);
                                PayParams payParams = new PayParams();
                                payParams.setItemId(payProduct.getItemId());
                                payParams.setItemName(payProduct.getPriceTag());
                                payParams.setAmount(Integer.parseInt(payProduct.getPrice()));
                                payParams.setCount(1);
                                payParams.setCallbackInfo(callbackInfo + "支付扩展信息");
                                payParams.addExtendParam("isSupportThirdPayment", "true");
                                payParams.addExtendParam("payType", "1");
                                payParams.addExtendParam("currency", payProduct.getPriceLocal());
                                FastSdk.pay(GameActivity.this, payParams, new PayCallback() {
                                    @Override
                                    public void onSuccess(String s) {
                                        LogUtils.i("Demo 提示:支付成功");
                                        Toast.makeText(GameActivity.this, "Demo 提示:支付成功" + s, Toast.LENGTH_SHORT).show();
                                    }

                                    @Override
                                    public void onFail(String s) {
                                        LogUtils.i("Demo 提示:支付失败");
                                        Toast.makeText(GameActivity.this, "Demo 提示:支付失败" + s, Toast.LENGTH_SHORT).show();
                                    }
                                });
                            }
                        });
                        builder.setView(listView);
                        builder.show();
                    }
                });
            }

            @Override
            public void onFail(String str) {
                Context context = GameActivity.this;
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append("商品列表获取失败:");
                stringBuilder.append(str);
                Toast.makeText(context, stringBuilder.toString(), Toast.LENGTH_SHORT).show();

            }
        });
    }

    /**
     * 获取声明在AndroidManifest.xml中meta标签中value值，注意value为数字获取为空
     */
    private void getMetaData() {
        final EditText et = new EditText(GameActivity.this);
        et.setHint("请输入Key");
        new AlertDialog.Builder(GameActivity.this).setTitle("请输入").setView(et).setPositiveButton("获取", new DialogInterface.OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {
                String key = et.getText().toString();
                if (TextUtils.isEmpty(key)) {
                    Toast.makeText(GameActivity.this, "请输入Key", Toast.LENGTH_SHORT).show();
                    return;
                }
                String result = FastSdk.getMetaDataConfig(GameActivity.this, key);
                Toast.makeText(GameActivity.this, result, Toast.LENGTH_SHORT).show();
            }
        }).show();
    }

    /**
     * 设置回调内容
     */
    private void setGameCallbackText() {
        final EditText numberText = new EditText(GameActivity.this);
        numberText.setInputType(android.text.InputType.TYPE_CLASS_TEXT);
        numberText.setHint("回调信息");
        numberText.setText(callbackInfo);

        new AlertDialog.Builder(GameActivity.this).setTitle("请输入").setIcon(android.R.drawable.ic_dialog_info).setView(numberText)
                .setPositiveButton("设置", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        String str = numberText.getText().toString();
                        if (TextUtils.isEmpty(str)) {
                            return;
                        }
                        callbackInfo = str;
                    }
                }).setNegativeButton("取消", null).show();
    }

    /**
     * 设置支付回调
     */
    private void setGameCallback() {
        final EditText numberText = new EditText(GameActivity.this);
        numberText.setInputType(android.text.InputType.TYPE_CLASS_NUMBER);
        numberText.setHint("回调信息长度");
        numberText.setText("" + callbackInfo.length());

        new AlertDialog.Builder(GameActivity.this).setTitle("请输入").setIcon(android.R.drawable.ic_dialog_info).setView(numberText)
                .setPositiveButton("设置", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        String str = numberText.getText().toString();
                        if (TextUtils.isEmpty(str)) {
                            return;
                        }
                        String result = "A";
                        for (int i = 1; i < Integer.parseInt(str); i++) {
                            result += new Random().nextInt(10);
                        }
                        callbackInfo = result;
                    }
                }).setNegativeButton("取消", null).show();
    }

    /**
     * 复制到粘贴板
     *
     * @param msg
     */
    private void copyClipboard(String msg) {
        ClipboardManager cmb = (ClipboardManager) getSystemService(CLIPBOARD_SERVICE);
        cmb.setText(msg);
        Toast.makeText(GameActivity.this, "成功复制到剪切板！", Toast.LENGTH_SHORT).show();
    }

    /**
     * 渠道特殊功能码调用
     *
     * @param funCode
     */
    private void specialInvoke(int funCode) {
        /**
         * 华为三方绑定
         */
        if (FastSdk.getChannelInfo().getChannel().equals("huawei")) {
            if (FastSdk.hasFunctionCode(funCode)) {
                FastSdk.invokeSpecialFunction(funCode, new CommonCallback() {
                    @Override
                    public void process(int i, boolean b, Object... objects) {
                        String msg = "";
                        if (objects[0] instanceof String) {
                            msg = (String) objects[0];
                        }
                        Toast.makeText(GameActivity.this, "绑定结果:" + i + ",b:" + b + ", msg:" + msg, Toast.LENGTH_SHORT).show();
                    }
                });
            }
        }

        /**
         * 冰鸟
         */
        if (FastSdk.getChannelInfo().getChannel().equals("bnoversea")) {
            FastSdk.invokeSpecialFunction(funCode, new CommonCallback() {
                @Override
                public void process(int i, boolean b, Object... objects) {

                    if (i == 121) {
                        if (b) {
                            Toast.makeText(GameActivity.this, "安卓冰鸟海外邮箱绑定成功！", Toast.LENGTH_SHORT).show();
                        } else if (objects != null) {
                            Toast.makeText(GameActivity.this, "安卓冰鸟海外万能接口接入错误，请检查！", Toast.LENGTH_SHORT).show();
                        } else {
                            Toast.makeText(GameActivity.this, "安卓冰鸟海外邮箱绑定失败！", Toast.LENGTH_SHORT).show();
                        }
                    }

                    if (i == 122) {
                        if (b) {
                            Toast.makeText(GameActivity.this, "安卓冰鸟海外fb share成功！", Toast.LENGTH_SHORT).show();
                        } else if (objects != null) {
                            Toast.makeText(GameActivity.this, "安卓冰鸟海外万能接口接入错误，请检查！", Toast.LENGTH_SHORT).show();
                        } else {
                            Toast.makeText(GameActivity.this, "安卓冰鸟海外fb share失败！", Toast.LENGTH_SHORT).show();
                        }
                    }

                }
            });
        }
        //信鸽推送
        if (FastSdk.hasFunctionCode(funCode)) {
            FastSdk.invokeSpecialFunction(funCode, new CommonCallback() {
                @Override
                public void process(int i, boolean b, Object... objects) {
                    String msg = "";
                    if (objects[0] instanceof String) {
                        msg = (String) objects[0];
                    }
                    LogUtils.i("信鸽调用类型：" + funCode);
                    LogUtils.i("信鸽调用结果：" + msg);
                }
            });
        }

        //Aihelp自定义导入数据到CRM系统（非必接）
        if (FastSdk.hasFunctionCode(funCode)) {
            Map<String, String> userExtData = new HashMap<String, String>();
            userExtData.put("ROLE_ID", "123123");
            userExtData.put("ROLE_NAME", "J");
            userExtData.put("SERVER_ID", "101");
            userExtData.put("VIP", "15");
            userExtData.put("ROLE_LEVEL", "200");
            userExtData.put("ZONE_NAME", "基地1");
            userExtData.put("BALANCE", "10");
            Boolean importCrm = true;//是否导入Ai-help CRM系统,ture导入,false不导入
            FastSdk.invokeSpecialFunction(funCode, userExtData, importCrm);
        }
    }

    private void doPay(int amount, String itemName, String itemId) {
        // 调用SDK支付功能
        PayParams payParams = new PayParams();
        payParams.setItemId(itemId);
        payParams.setItemName(itemName);
        payParams.setAmount(amount);
        payParams.setCount(123);
        payParams.setCallbackInfo(callbackInfo);
        //payParams.addExtendParam(PayParams.NOTIFY_URL_KEY, "http://a.b.com");//游戏自定义支付回调地址,不设置默认使用后台配置
        payParams.addExtendParam("isSupportThirdPayment", "false");//是否显示三方支付 true显示 false不显示

        FastSdk.pay(GameActivity.this, payParams, new PayCallback() {
            @Override
            public void onSuccess(String param) {
                //支付成功后，该回调不能用作判定支付成功，只能判定支付客户端行为完成
                //支付是否成功要以服务端回调为准
            }

            @Override
            public void onFail(String param) {
                //有可能是支付失败，取消支付界面等情况
                //支付失败（取消支付框回调）回调，并不是每个渠道都会有这个回调，所以建议不要完全依赖该回调实现一些功能。
                //(例如只有收到支付失败回调才会关闭loding框或者蒙板，这样会导致一些渠道会有问题)
            }
        });
    }

    private void exit() {
        // 调用SDK退出功能
        FastSdk.exit(GameActivity.this, null, new ExitCallback() {
            @Override
            public void onExitSuccess(String s) {
                // 渠道存在退出界面，如91、360等，此处只需进行退出逻辑即可，无需再弹游戏退出界面
                // 实现退出逻辑，请勿直接照搬demo
//				System.exit(0);
                moveTaskToBack(true);
                finish();
                //                        // 退出程序
                Intent intent = new Intent(Intent.ACTION_MAIN);
                intent.addCategory(Intent.CATEGORY_HOME);
                intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                startActivity(intent);
                android.os.Process.killProcess(android.os.Process.myPid());

//				FastSdk.exit();
            }

            @Override
            public void onCustomExit(final String s) {
                // 渠道不存在退出界面，如百度移动游戏等，此时需在此处弹出游戏退出确认界面，否则会出现渠道审核不通过情况
                // 游戏实现自己的退出界面 ，实现退出逻辑，请勿直接照搬demo
                // 根据需要加二次确认框
                new AlertDialog.Builder(GameActivity.this).setTitle("游戏二次确认").setNegativeButton("取消", null).setPositiveButton("确定", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        onExitSuccess(s);
                    }
                }).setCancelable(false).show();
            }
        });
    }

    @Override
    protected void onStart() {
        super.onStart();
        FastSdk.onStart(this);
    }

    @Override
    protected void onRestart() {
        super.onRestart();
        FastSdk.onRestart(this);
    }

    @Override
    protected void onResume() {
        super.onResume();
        FastSdk.onResume(this);
    }

    @Override
    protected void onPause() {
        super.onPause();
        FastSdk.onPause(this);
    }

    @Override
    protected void onStop() {
        super.onStop();
        FastSdk.onStop(this);
    }

    @Override
    protected void onDestroy() {
        try {
            super.onDestroy();
            FastSdk.onDestroy(this);
        } catch (Exception e) {
            Log.e(TAG, "onDestroy occured exception", e);
        }
        // funCode = 120（信鸽初始化，如果使用信鸽功能只有此功能必接，其他信鸽功能选接）
        if (FastSdk.hasFunctionCode(120)) {
            FastSdk.invokeSpecialFunction(120, new CommonCallback() {
                @Override
                public void process(int i, boolean b, Object... objects) {
                    if (objects[0] instanceof org.json.JSONObject) {
                        JSONObject result = (JSONObject) objects[0];
                    }
                }
            });
        }
        // funCode = 121（XG更新标签）
        if (FastSdk.hasFunctionCode(121)) {
            String[] addTags = {"tag1", "tag2"};//要添加的标签
            FastSdk.invokeSpecialFunction(121, (Object) addTags);
        }
        // funCode = 122（XG删除标签）
        if (FastSdk.hasFunctionCode(122)) {
            String[] delTags = {"tag1", "tag2"};//要删除的标签
            FastSdk.invokeSpecialFunction(122, (Object) delTags);
        }
        // funCode = 123（XG查询标签）
        if (FastSdk.hasFunctionCode(123)) {
            FastSdk.invokeSpecialFunction(123, new CommonCallback() {
                @Override
                public void process(int i, boolean b, Object... objects) {
                    if (objects[0] instanceof String) {
                        String result = (String) objects[0];
                    }
                }
            });
        }
        // funCode = 124（XG清空标签）
        if (FastSdk.hasFunctionCode(124)) {
            FastSdk.invokeSpecialFunction(124);
        }
        // funCode = 125（XG取消推送）
        if (FastSdk.hasFunctionCode(125)) {
            FastSdk.invokeSpecialFunction(125);
        }
        // funCode = 126（XG上传日志）
        if (FastSdk.hasFunctionCode(126)) {
            FastSdk.invokeSpecialFunction(126);
        }
        // funCode = 127（XG获取token）
        if (FastSdk.hasFunctionCode(127)) {
            FastSdk.invokeSpecialFunction(127, new CommonCallback() {
                @Override
                public void process(int i, boolean b, Object... objects) {
                    if (objects[0] instanceof String) {
                        String token = (String) objects[0];
                    }
                }
            });
        }
        // funCode = 128（XG设置CRM用户信息）
        if (FastSdk.hasFunctionCode(128)) {
            Map<String, String> map = new HashMap<>();
            Boolean importCrm = true;
            FastSdk.invokeSpecialFunction(128, map, importCrm);
        }
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        FastSdk.onConfigurationChanged(this, newConfig);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent intent) {
        super.onActivityResult(requestCode, resultCode, intent);
        FastSdk.onActivityResult(this, requestCode, resultCode, intent);
    }

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        FastSdk.onNewIntent(intent);
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        FastSdk.onSaveInstanceState(outState);
    }

    @Override
    public void onBackPressed() {
        FastSdk.onBackPressed();
        exit();
    }

    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        return FastSdk.dispatchKeyEvent(event) || super.dispatchKeyEvent(event);
    }

    @Override
    public boolean dispatchTouchEvent(MotionEvent ev) {
        return FastSdk.dispatchTouchEvent(ev) || super.dispatchTouchEvent(ev);
    }

    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {
        FastSdk.onRequestPermissionsResult(requestCode, permissions, grantResults);
    }

}
